Index: code/branches/mac_osx/src/external/bullet/BulletCollision/NarrowPhaseCollision/btGjkPairDetector.cpp
===================================================================
--- code/branches/mac_osx/src/external/bullet/BulletCollision/NarrowPhaseCollision/btGjkPairDetector.cpp	(revision 8042)
+++ code/branches/mac_osx/src/external/bullet/BulletCollision/NarrowPhaseCollision/btGjkPairDetector.cpp	(revision 8043)
@@ -38,10 +38,4 @@
 int gNumGjkChecks = 0;
 
-#ifdef check
-struct CompilerError
-{
-    void CompilerError() {}
-};
-#endif
 
 
Index: code/branches/mac_osx/src/libraries/core/DynLib.h
===================================================================
--- code/branches/mac_osx/src/libraries/core/DynLib.h	(revision 8042)
+++ code/branches/mac_osx/src/libraries/core/DynLib.h	(revision 8043)
@@ -110,4 +110,5 @@
 
     protected:
+
         /// Handle to the loaded library.
         DYNLIB_HANDLE m_hInst;
Index: code/branches/mac_osx/src/libraries/core/GUIManager.cc
===================================================================
--- code/branches/mac_osx/src/libraries/core/GUIManager.cc	(revision 8042)
+++ code/branches/mac_osx/src/libraries/core/GUIManager.cc	(revision 8043)
@@ -351,5 +351,4 @@
     void GUIManager::buttonPressed(MouseButtonCode::ByEnum id)
     {
-        //guiSystem_->injectMouseButtonDown(convertButton(id));
         this->protectedCall(boost::bind(&CEGUI::System::injectMouseButtonDown, _1, convertButton(id)));
     }
Index: code/branches/mac_osx/src/libraries/core/GraphicsManager.cc
===================================================================
--- code/branches/mac_osx/src/libraries/core/GraphicsManager.cc	(revision 8042)
+++ code/branches/mac_osx/src/libraries/core/GraphicsManager.cc	(revision 8043)
@@ -314,5 +314,5 @@
 
         Ogre::WindowEventUtilities::addWindowEventListener(this->renderWindow_, ogreWindowEventListener_.get());
-		
+
 // HACK
 #ifdef ORXONOX_PLATFORM_APPLE
@@ -323,5 +323,5 @@
 #endif
 // End of HACK
-		
+
         // create a full screen default viewport
         // Note: This may throw when adding a viewport with an existing z-order!
Index: code/branches/mac_osx/src/libraries/core/PathConfig.cc
===================================================================
--- code/branches/mac_osx/src/libraries/core/PathConfig.cc	(revision 8042)
+++ code/branches/mac_osx/src/libraries/core/PathConfig.cc	(revision 8043)
@@ -206,6 +206,4 @@
 #ifdef ORXONOX_PLATFORM_UNIX
             char* userDataPathPtr(getenv("HOME"));
-#elif ORXONOX_PLATFORM_APPLE
-            char* userDataPathPtr(getenv("HOME"));
 #else
             char* userDataPathPtr(getenv("APPDATA"));
Index: code/branches/mac_osx/src/orxonox/MoodManager.cc
===================================================================
--- code/branches/mac_osx/src/orxonox/MoodManager.cc	(revision 8042)
+++ code/branches/mac_osx/src/orxonox/MoodManager.cc	(revision 8043)
@@ -50,6 +50,6 @@
 
         // Checking for the existence of the folder for the default mood
-        const std::string& patha = "ambient/" + MoodManager::defaultMood_ + "/.";
-        if (!Resource::exists(patha))
+        const std::string& path = "ambient/" + MoodManager::defaultMood_ + "/.";
+        if (!Resource::exists(path))
         {
             // TODO: Non-fatal error handling (non-critical resource missing)
Index: code/branches/mac_osx/src/orxonox/sound/SoundManager.cc
===================================================================
--- code/branches/mac_osx/src/orxonox/sound/SoundManager.cc	(revision 8042)
+++ code/branches/mac_osx/src/orxonox/sound/SoundManager.cc	(revision 8043)
@@ -83,5 +83,5 @@
         SetConfigValue(bDisableSound_, false);
         if (bDisableSound_)
-            ThrowException(InitialisationAborted, "Sound: Not loading at all");        
+            ThrowException(InitialisationAborted, "Sound: Not loading at all");
         if (!alutInitWithoutContext(NULL, NULL))
             ThrowException(InitialisationFailed, "Sound Error: ALUT initialisation failed: " << alutGetErrorString(alutGetError()));
@@ -131,8 +131,8 @@
         GameMode::setPlaysSound(true);
         Loki::ScopeGuard resetPlaysSoundGuard = Loki::MakeGuard(&GameMode::setPlaysSound, false);
-        
+
         // Get some information about the sound
         if (const char* version = alGetString(AL_VERSION))
-            COUT(4) << "Sound: --- OpenAL Version: " << version << std::endl;            
+            COUT(4) << "Sound: --- OpenAL Version: " << version << std::endl;
         if (const char* vendor = alGetString(AL_VENDOR))
             COUT(4) << "Sound: --- OpenAL Vendor : " << vendor << std::endl;